package com.sun.corba.se.impl.encoding;

import com.sun.corba.se.impl.logging.ORBUtilSystemException;
import com.sun.corba.se.pept.protocol.MessageMediator;
import com.sun.org.omg.SendingContext.CodeBase;
import org.omg.CORBA.DoubleSeqHolder;
import org.omg.CORBA.FloatSeqHolder;
import org.omg.CORBA.LongLongSeqHolder;
import org.omg.CORBA.ULongLongSeqHolder;
import org.omg.CORBA.ULongSeqHolder;
import org.omg.CORBA.LongSeqHolder;
import org.omg.CORBA.UShortSeqHolder;
import org.omg.CORBA.ShortSeqHolder;
import org.omg.CORBA.OctetSeqHolder;
import org.omg.CORBA.WCharSeqHolder;
import org.omg.CORBA.CharSeqHolder;
import org.omg.CORBA.BooleanSeqHolder;
import org.omg.CORBA.AnySeqHolder;
import org.omg.CORBA.portable.BoxedValueHelper;
import java.io.Serializable;
import org.omg.CORBA.Context;
import java.math.BigDecimal;
import java.io.IOException;
import org.omg.CORBA.Principal;
import org.omg.CORBA.Any;
import org.omg.CORBA.TypeCode;
import org.omg.CORBA.Object;
import com.sun.corba.se.spi.ior.iiop.GIOPVersion;
import java.nio.ByteBuffer;
import org.omg.CORBA.ORB;
import com.sun.corba.se.spi.protocol.CorbaMessageMediator;
import org.omg.CORBA.portable.ValueInputStream;
import org.omg.CORBA.DataInputStream;
import org.omg.CORBA_2_3.portable.InputStream;

public abstract class CDRInputStream extends InputStream implements MarshalInputStream, DataInputStream, ValueInputStream
{
    protected CorbaMessageMediator messageMediator;
    private CDRInputStreamBase impl;
    
    public CDRInputStream() {
    }
    
    public CDRInputStream(CDRInputStream cdrInputStream) {
        (this.impl = cdrInputStream.impl.dup()).setParent(this);
    }
    
    public CDRInputStream(ORB orb, ByteBuffer byteBuffer, int n, boolean b, GIOPVersion giopVersion, byte b2, BufferManagerRead bufferManagerRead) {
        (this.impl = CDRInputStream.InputStreamFactory.newInputStream((com.sun.corba.se.spi.orb.ORB)orb, giopVersion, b2)).init(orb, byteBuffer, n, b, bufferManagerRead);
        this.impl.setParent(this);
    }
    
    public final boolean read_boolean() {
        return this.impl.read_boolean();
    }
    
    public final char read_char() {
        return this.impl.read_char();
    }
    
    public final char read_wchar() {
        return this.impl.read_wchar();
    }
    
    public final byte read_octet() {
        return this.impl.read_octet();
    }
    
    public final short read_short() {
        return this.impl.read_short();
    }
    
    public final short read_ushort() {
        return this.impl.read_ushort();
    }
    
    public final int read_long() {
        return this.impl.read_long();
    }
    
    public final int read_ulong() {
        return this.impl.read_ulong();
    }
    
    public final long read_longlong() {
        return this.impl.read_longlong();
    }
    
    public final long read_ulonglong() {
        return this.impl.read_ulonglong();
    }
    
    public final float read_float() {
        return this.impl.read_float();
    }
    
    public final double read_double() {
        return this.impl.read_double();
    }
    
    public final String read_string() {
        return this.impl.read_string();
    }
    
    public final String read_wstring() {
        return this.impl.read_wstring();
    }
    
    public final void read_boolean_array(boolean[] array, int n, int n2) {
        this.impl.read_boolean_array(array, n, n2);
    }
    
    public final void read_char_array(char[] array, int n, int n2) {
        this.impl.read_char_array(array, n, n2);
    }
    
    public final void read_wchar_array(char[] array, int n, int n2) {
        this.impl.read_wchar_array(array, n, n2);
    }
    
    public final void read_octet_array(byte[] array, int n, int n2) {
        this.impl.read_octet_array(array, n, n2);
    }
    
    public final void read_short_array(short[] array, int n, int n2) {
        this.impl.read_short_array(array, n, n2);
    }
    
    public final void read_ushort_array(short[] array, int n, int n2) {
        this.impl.read_ushort_array(array, n, n2);
    }
    
    public final void read_long_array(int[] array, int n, int n2) {
        this.impl.read_long_array(array, n, n2);
    }
    
    public final void read_ulong_array(int[] array, int n, int n2) {
        this.impl.read_ulong_array(array, n, n2);
    }
    
    public final void read_longlong_array(long[] array, int n, int n2) {
        this.impl.read_longlong_array(array, n, n2);
    }
    
    public final void read_ulonglong_array(long[] array, int n, int n2) {
        this.impl.read_ulonglong_array(array, n, n2);
    }
    
    public final void read_float_array(float[] array, int n, int n2) {
        this.impl.read_float_array(array, n, n2);
    }
    
    public final void read_double_array(double[] array, int n, int n2) {
        this.impl.read_double_array(array, n, n2);
    }
    
    public final org.omg.CORBA.Object read_Object() {
        return this.impl.read_Object();
    }
    
    public final TypeCode read_TypeCode() {
        return this.impl.read_TypeCode();
    }
    
    public final Any read_any() {
        return this.impl.read_any();
    }
    
    public final Principal read_Principal() {
        return this.impl.read_Principal();
    }
    
    public final int read() throws IOException {
        return this.impl.read();
    }
    
    public final BigDecimal read_fixed() {
        return this.impl.read_fixed();
    }
    
    public final Context read_Context() {
        return this.impl.read_Context();
    }
    
    public final org.omg.CORBA.Object read_Object(Class clazz) {
        return this.impl.read_Object(clazz);
    }
    
    public final ORB orb() {
        return this.impl.orb();
    }
    
    public final Serializable read_value() {
        return this.impl.read_value();
    }
    
    public final Serializable read_value(Class clazz) {
        return this.impl.read_value(clazz);
    }
    
    public final Serializable read_value(BoxedValueHelper boxedValueHelper) {
        return this.impl.read_value(boxedValueHelper);
    }
    
    public final Serializable read_value(String s) {
        return this.impl.read_value(s);
    }
    
    public final Serializable read_value(Serializable s) {
        return this.impl.read_value(s);
    }
    
    public final Object read_abstract_interface() {
        return this.impl.read_abstract_interface();
    }
    
    public final Object read_abstract_interface(Class clazz) {
        return this.impl.read_abstract_interface(clazz);
    }
    
    public final void consumeEndian() {
        this.impl.consumeEndian();
    }
    
    public final int getPosition() {
        return this.impl.getPosition();
    }
    
    public final Object read_Abstract() {
        return this.impl.read_Abstract();
    }
    
    public final Serializable read_Value() {
        return this.impl.read_Value();
    }
    
    public final void read_any_array(AnySeqHolder anySeqHolder, int n, int n2) {
        this.impl.read_any_array(anySeqHolder, n, n2);
    }
    
    public final void read_boolean_array(BooleanSeqHolder booleanSeqHolder, int n, int n2) {
        this.impl.read_boolean_array(booleanSeqHolder, n, n2);
    }
    
    public final void read_char_array(CharSeqHolder charSeqHolder, int n, int n2) {
        this.impl.read_char_array(charSeqHolder, n, n2);
    }
    
    public final void read_wchar_array(WCharSeqHolder wCharSeqHolder, int n, int n2) {
        this.impl.read_wchar_array(wCharSeqHolder, n, n2);
    }
    
    public final void read_octet_array(OctetSeqHolder octetSeqHolder, int n, int n2) {
        this.impl.read_octet_array(octetSeqHolder, n, n2);
    }
    
    public final void read_short_array(ShortSeqHolder shortSeqHolder, int n, int n2) {
        this.impl.read_short_array(shortSeqHolder, n, n2);
    }
    
    public final void read_ushort_array(UShortSeqHolder uShortSeqHolder, int n, int n2) {
        this.impl.read_ushort_array(uShortSeqHolder, n, n2);
    }
    
    public final void read_long_array(LongSeqHolder longSeqHolder, int n, int n2) {
        this.impl.read_long_array(longSeqHolder, n, n2);
    }
    
    public final void read_ulong_array(ULongSeqHolder uLongSeqHolder, int n, int n2) {
        this.impl.read_ulong_array(uLongSeqHolder, n, n2);
    }
    
    public final void read_ulonglong_array(ULongLongSeqHolder uLongLongSeqHolder, int n, int n2) {
        this.impl.read_ulonglong_array(uLongLongSeqHolder, n, n2);
    }
    
    public final void read_longlong_array(LongLongSeqHolder longLongSeqHolder, int n, int n2) {
        this.impl.read_longlong_array(longLongSeqHolder, n, n2);
    }
    
    public final void read_float_array(FloatSeqHolder floatSeqHolder, int n, int n2) {
        this.impl.read_float_array(floatSeqHolder, n, n2);
    }
    
    public final void read_double_array(DoubleSeqHolder doubleSeqHolder, int n, int n2) {
        this.impl.read_double_array(doubleSeqHolder, n, n2);
    }
    
    public final String[] _truncatable_ids() {
        return this.impl._truncatable_ids();
    }
    
    public final int read(byte[] b) throws IOException {
        return this.impl.read(b);
    }
    
    public final int read(byte[] b, int off, int len) throws IOException {
        return this.impl.read(b, off, len);
    }
    
    public final long skip(long n) throws IOException {
        return this.impl.skip(n);
    }
    
    public final int available() throws IOException {
        return this.impl.available();
    }
    
    public final void close() throws IOException {
        this.impl.close();
    }
    
    public final void mark(int n) {
        this.impl.mark(n);
    }
    
    public final void reset() {
        this.impl.reset();
    }
    
    public final boolean markSupported() {
        return this.impl.markSupported();
    }
    
    public abstract CDRInputStream dup();
    
    public final BigDecimal read_fixed(short n, short n2) {
        return this.impl.read_fixed(n, n2);
    }
    
    public final boolean isLittleEndian() {
        return this.impl.isLittleEndian();
    }
    
    protected final ByteBuffer getByteBuffer() {
        return this.impl.getByteBuffer();
    }
    
    protected final void setByteBuffer(ByteBuffer byteBuffer) {
        this.impl.setByteBuffer(byteBuffer);
    }
    
    protected final void setByteBufferWithInfo(ByteBufferWithInfo byteBufferWithInfo) {
        this.impl.setByteBufferWithInfo(byteBufferWithInfo);
    }
    
    protected final boolean isSharing(ByteBuffer byteBuffer) {
        return this.getByteBuffer() == byteBuffer;
    }
    
    public final int getBufferLength() {
        return this.impl.getBufferLength();
    }
    
    protected final void setBufferLength(int bufferLength) {
        this.impl.setBufferLength(bufferLength);
    }
    
    protected final int getIndex() {
        return this.impl.getIndex();
    }
    
    protected final void setIndex(int index) {
        this.impl.setIndex(index);
    }
    
    public final void orb(ORB orb) {
        this.impl.orb(orb);
    }
    
    public final GIOPVersion getGIOPVersion() {
        return this.impl.getGIOPVersion();
    }
    
    public final BufferManagerRead getBufferManager() {
        return this.impl.getBufferManager();
    }
    
    public CodeBase getCodeBase() {
        return null;
    }
    
    protected CodeSetConversion.BTCConverter createCharBTCConverter() {
        return CodeSetConversion.impl().getBTCConverter(OSFCodeSetRegistry.ISO_8859_1, this.impl.isLittleEndian());
    }
    
    protected abstract CodeSetConversion.BTCConverter createWCharBTCConverter();
    
    void printBuffer() {
        this.impl.printBuffer();
    }
    
    public void alignOnBoundary(int n) {
        this.impl.alignOnBoundary(n);
    }
    
    public void setHeaderPadding(boolean headerPadding) {
        this.impl.setHeaderPadding(headerPadding);
    }
    
    public void performORBVersionSpecificInit() {
        if (this.impl != null) {
            this.impl.performORBVersionSpecificInit();
        }
    }
    
    public void resetCodeSetConverters() {
        this.impl.resetCodeSetConverters();
    }
    
    public void setMessageMediator(MessageMediator messageMediator) {
        this.messageMediator = (CorbaMessageMediator)messageMediator;
    }
    
    public MessageMediator getMessageMediator() {
        return this.messageMediator;
    }
    
    public void start_value() {
        this.impl.start_value();
    }
    
    public void end_value() {
        this.impl.end_value();
    }
    
    private static class InputStreamFactory
    {
        public static CDRInputStreamBase newInputStream(com.sun.corba.se.spi.orb.ORB orb, GIOPVersion giopVersion, byte b) {
            switch (giopVersion.intValue()) {
                case 256: {
                    return new CDRInputStream_1_0();
                }
                case 257: {
                    return new CDRInputStream_1_1();
                }
                case 258: {
                    if (b != 0) {
                        return new IDLJavaSerializationInputStream(b);
                    }
                    return new CDRInputStream_1_2();
                }
                default: {
                    throw ORBUtilSystemException.get(orb, "rpc.encoding").unsupportedGiopVersion(giopVersion);
                }
            }
        }
    }
}
